<p align="center">
<img src=".github/media/jsf_logo_dark.png"  width="600" alt="json-schema-form">
</p>

<p align="center">
  <code>json-schema-form</code> is a headless UI form library powered by <a href="https://json-schema.org/">JSON Schemas</a>. 
<br/>
  It transforms JSON schemas into Javascript `fields` to be more easily consumed by your UI libraries.
</p>

---

### Why JSON Schemas for forms?

JSON Schemas are the SSoT (Single Source of Truth) that allows you to share form's data _structure_ and _validations_ between the server (backend) and the client (frontend), regardless of the language used.

You can use it beyond UI Forms, like lists, tables, and any other UI that needs structured JSON data.

## Installation

Available on [NPM](https://www.npmjs.com/package/@remoteoss/json-schema-form).

```bash
npm install @remoteoss/json-schema-form
# or

yarn install @remoteoss/json-schema-form
```

## Getting Started

Check the 📚 **[JSF website](https://json-schema-form.vercel.app/)** for documentation.

### Playground

Check the 🕹️ **[JSF Playground](https://json-schema-form.vercel.app/?path=/docs/playground--docs)** for demos.

## Contributing

Read [CONTRIBUTING](CONTRIBUTING.md) to get started.

We are working on the [next version v1.0](/next). A rewrite in TypeScript with major bugfixes and missing features. It aims to support the latest JSON Schema dialect 2020-12.

_Backed by [Remote.com](https://remote.com/)_
